local mod = ...


-- Cards ------------------------------------------------------------------------------------
-- These are actions that can be taken as part of a monthly notification



-- Set up Cards ------------------------------------------------------------------------------------
local cardChoice = {}

mod:registerEnumValue( "BUDGET_CATEGORY", "BUDGET_CATEGORY_LOAN" )
mod:registerEnumValue( "BUDGET_CATEGORY", "BUDGET_CATEGORY_GIFT" )



-- Create quest containers with the event description, used visually to describe the choice in the tooltip
for i = 1, 50 do
    mod:registerAsset({
        DataType = "QUEST",
        Id = "QUEST_IAE_CONTAINER_" .. string.sub("000" .. i, -3),
        IsSilent = true,
        QuestFunction = {
            DataType = "QUEST_FUNCTION_CONTAINER",
            QuestContainerDescription = "EVENT_IAE_CARD_"  .. string.sub("000" .. i, -3) .. "_DESC",
        },
    })
end



-- -- Gold rewards depending on population, to be used in multiple events
-- for i=0, 1000, 10 do
--     mod:registerAsset({
--         DataType = "EVENT",
--         Id = "EVENT_IAE_POPULATION_" .. string.sub("0000" .. i, -4),
--         DaysToFirst = 1,
--         ConditionList = {
--             {
--                 DataType = "GAME_CONDITION_VILLAGER_STATUS_REACHED",
--                 AssetVillagerStatus = "SERF",
--                 NumberRequired = i
--             },
--         },
--         ActionList = {
--             {
--                 DataType = "ACTION_SHOW_NARRATIVE_PANEL",
--                 NarrativePanelData = {
--                     Title = "newcomers reached " .. i,
--                     Description = "newcomers reached " .. i,
--                     PanelVisual = "ILLUSTRATION_ESTATE_KING",
--                 },
--                 ChoiceList = {
--                     {
--                         ShortName = "TEXT_IAE_OK",
--                     },
--                 },
--             },
--             {
--                 DataType = "EVENT_ACTION_GIVE_REWARD",
--                 ActionList = {
--                     {
--                         DataType = "QUEST_REWARD_RESOURCES",
--                         BudgetCategory = "TAX_OFFICE",
--                         ResourceCollection = {
--                             {
--                                 Resource = "GOLD_COINS",
--                                 Quantity = 100
--                             },
--                         },
--                     },
--                 },
--             },
--             {
--                 DataType = "GAME_ACTION_TRIGGER_EVENT_CALLBACK",
--                 Callback = {
--                     DataType = "EVENT_CALLBACK_TRIGGER_EVENT",
--                     Event = "EVENT_IAE_POPULATION_" .. string.sub("0000" .. i+10, -4),
--                     Delay = 30,
--                 },
--             },
--         },
--     })
-- end

-- mod:registerAsset({
--     DataType = "EVENT",
--     Id = "EVENT_IAE_POPULATION_1010",
--     DaysToFirst = 1,
-- })

-- local listEventPopulation = {
--     { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0000", Delay = 0 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0010", Delay = 30 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0020", Delay = 60 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0030", Delay = 90 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0040", Delay = 120 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0050", Delay = 150 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0060", Delay = 180 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0070", Delay = 210 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0080", Delay = 240 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0090", Delay = 270 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0100", Delay = 300 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0110", Delay = 330 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0120", Delay = 360 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0130", Delay = 390 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0140", Delay = 420 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0150", Delay = 450 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0160", Delay = 480 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0170", Delay = 510 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0180", Delay = 540 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0190", Delay = 570 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0200", Delay = 600 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0210", Delay = 630 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0220", Delay = 660 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0230", Delay = 690 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0240", Delay = 720 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0250", Delay = 750 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0260", Delay = 780 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0270", Delay = 810 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0280", Delay = 840 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0290", Delay = 870 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0300", Delay = 900 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0310", Delay = 930 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0320", Delay = 960 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0330", Delay = 990 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0340", Delay = 1020 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0350", Delay = 1050 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0360", Delay = 1080 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0370", Delay = 1110 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0380", Delay = 1140 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0390", Delay = 1170 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0400", Delay = 1200 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0410", Delay = 1230 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0420", Delay = 1260 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0430", Delay = 1290 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0440", Delay = 1320 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0450", Delay = 1350 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0460", Delay = 1380 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0470", Delay = 1410 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0480", Delay = 1440 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0490", Delay = 1470 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0500", Delay = 1500 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0510", Delay = 1530 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0520", Delay = 1560 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0530", Delay = 1590 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0540", Delay = 1620 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0550", Delay = 1650 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0560", Delay = 1680 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0570", Delay = 1710 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0580", Delay = 1740 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0590", Delay = 1770 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0600", Delay = 1800 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0610", Delay = 1830 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0620", Delay = 1860 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0630", Delay = 1890 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0640", Delay = 1920 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0650", Delay = 1950 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0660", Delay = 1980 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0670", Delay = 2010 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0680", Delay = 2040 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0690", Delay = 2070 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0700", Delay = 2100 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0710", Delay = 2130 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0720", Delay = 2160 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0730", Delay = 2190 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0740", Delay = 2220 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0750", Delay = 2250 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0760", Delay = 2280 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0770", Delay = 2310 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0780", Delay = 2340 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0790", Delay = 2370 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0800", Delay = 2400 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0810", Delay = 2430 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0820", Delay = 2460 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0830", Delay = 2490 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0840", Delay = 2520 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0850", Delay = 2550 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0860", Delay = 2580 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0870", Delay = 2610 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0880", Delay = 2640 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0890", Delay = 2670 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0900", Delay = 2700 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0910", Delay = 2730 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0920", Delay = 2760 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0930", Delay = 2790 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0940", Delay = 2820 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0950", Delay = 2850 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0960", Delay = 2880 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0970", Delay = 2910 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0980", Delay = 2940 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_0990", Delay = 2970 },
    -- { DataType = "EVENT_CALLBACK_TRIGGER_EVENT", Event = "EVENT_IAE_POPULATION_1000", Delay = 3000 },
-- }



-- List of all resources affected by production
local listEventResourceAll = {
    "BERRIES",
    "MILK",
    "CHEESE",
    "BV1_BUTTER",
    "FISH",
    "BV1_EGG",
    "RESOURCE_POULTRY",
    "RESOURCE_VEGETABLE",
    "RESOURCE_MUSHROOM",
    "BOAR",
    "LEATHER",
    "BV1_CARCASS",
    "BV1_MEAT",
    "WHEAT",
    "FLOUR",
    "BREAD",
    "WOOD",
    "PLANK",
    "RESOURCE_SHINGLE",
    "STONE",
    "POLISHED_STONE",
    -- "RESOURCE_CANDLE",
    "RESOURCE_THATCH",
    "RESOURCE_CLAY",
    "RESOURCE_POTTERY",
    "RESOURCE_TILE",
    "RESOURCE_FLAX",
    "WOOL",
    "WOOLEN_CLOTH",
    "CLOTHES",
    "RESOURCE_FURNITURE",
    "HOP",
    "BEER",
    "GRAPES",
    "WINE",
    "RESOURCE_FRUIT",
    "RESOURCE_CIDER",
    "HONEY",
    "MEAL",
    "HERBS",
    "BV1_PASTRY",
    "BV1_SALT",
    "BV1_SUGAR",
    "BARREL",
    "COAL",
    "IRON_ORE",
    "IRON",
    "MARBLE",
    "SCULPTURE",
    "GOLD_ORE",
    "GOLD_BARS",
    "QUARTZ",
    "GLASS",
    "STAINED_GLASS",
    "TOOL",
    "GEMS",
    "JEWELRY",
    "CANDLE",
    "COMMON_WARES",
}

local listEventResourceFood = {
    "BERRIES",
    "MILK",
    "CHEESE",
    "BV1_BUTTER",
    "FISH",
    "BV1_EGG",
    "RESOURCE_POULTRY",
    "RESOURCE_VEGETABLE",
    "RESOURCE_MUSHROOM",
    "BOAR",
    "BV1_CARCASS",
    "BV1_MEAT",
    "WHEAT",
    "FLOUR",
    "BREAD",
    "HOP",
    "BEER",
    "GRAPES",
    "WINE",
    "RESOURCE_FRUIT",
    "RESOURCE_CIDER",
    "HONEY",
    "MEAL",
    "HERBS",
    "BV1_PASTRY",
    "BV1_SALT",
    "BV1_SUGAR",
}

local listEventResourceGoods = {
    "LEATHER",
    "WOOD",
    "PLANK",
    "RESOURCE_SHINGLE",
    "STONE",
    "POLISHED_STONE",
    -- "RESOURCE_CANDLE",
    "RESOURCE_THATCH",
    "RESOURCE_CLAY",
    "RESOURCE_POTTERY",
    "RESOURCE_TILE",
    "RESOURCE_FLAX",
    "WOOL",
    "WOOLEN_CLOTH",
    "CLOTHES",
    "RESOURCE_FURNITURE",
    "BARREL",
    "COAL",
    "IRON_ORE",
    "IRON",
    "MARBLE",
    "SCULPTURE",
    "GOLD_ORE",
    "GOLD_BARS",
    "QUARTZ",
    "GLASS",
    "STAINED_GLASS",
    "TOOL",
    "JEWELRY",
    "CANDLE",
    "COMMON_WARES",
}



-- 001 - Declare Special Tax
-- Receive gold income in exchange for labour influence and happiness
cardChoice[1] = {
    DataType = "EVENT_CHOICE",
    ShortName = "EVENT_IAE_CARD_001_NAME",
    EventActionList = {
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_IAE_CONTAINER_001",
        },
        {
            DataType = "ACTION_SHOW_NARRATIVE_PANEL",
            NarrativePanelData = {
                Title = "EVENT_IAE_CARD_001_NAME",
                Description = "EVENT_IAE_CARD_001_DESC",
                PanelVisual = "ILLUSTRATION_ESTATE_LABOR",
            },
            ChoiceList = {
                {
                    ShortName = "TEXT_IAE_OK",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "GAME_ACTION_GIVE_RESOURCE_LIST",
                                    BudgetCategory = "TAX_OFFICE",
                                    ResourceCollection = {
                                        {
                                            Resource = "GOLD_COINS",
                                            Quantity = 500,
                                        },
                                    },
                                },
                                {
                                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                                    EstateInfluence = {
                                        Estate = "LABOUR",
                                        Quantity = -5,
                                    },
                                },
                                {
                                    DataType = "QUEST_REWARD_GAME_RULE",
                                    RuleModifier = {
                                        DataType = "GAME_RULE_MODIFIER_HAPPINESS",
                                        Name = "EVENT_IAE_CARD_001_NAME",
                                        DurationInDays = 60,
                                        BonusHappinessPercentage = -0.10,
                                    },
                                },
                            },
                        },
                    },
                    -- OnClickCallbackList = listEventPopulation,
                },
                {
                    ShortName = "TEXT_IAE_CANCEL",
                },
            },
        },
    },
}


-- 002 - Indenture Villagers to the King
-- receive gold income and influence in exchange for diverting 10% of production to the King
cardChoice[2] = {
    DataType = "EVENT_CHOICE",
    ShortName = "EVENT_IAE_CARD_002_NAME",
    EventActionList = {
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_IAE_CONTAINER_002",
        },
        {
            DataType = "ACTION_SHOW_NARRATIVE_PANEL",
            NarrativePanelData = {
                Title = "EVENT_IAE_CARD_002_NAME",
                Description = "EVENT_IAE_CARD_002_DESC",
                PanelVisual = "ILLUSTRATION_ESTATE_KING",
            },
            ChoiceList = {
                {
                    ShortName = "TEXT_IAE_OK",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "GAME_ACTION_GIVE_RESOURCE_LIST",
                                    BudgetCategory = "TAX_OFFICE",
                                    ResourceCollection = {
                                        {
                                            Resource = "GOLD_COINS",
                                            Quantity = 500,
                                        },
                                    },
                                },
                                {
                                    DataType = "GAME_ACTION_APPLY_GAME_RULE",
                                    RuleModifier = {
                                        DataType = "GAME_RULE_MODIFIER_CROP_YIELDS",
                                        ResourceList = listEventResourceAll,
                                        YieldPercentage = 0.9,
                                        DurationInDays = 60,
                                    },
                                },
                                {
                                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                                    EstateInfluence = {
                                        Estate = "KINGDOM",
                                        Quantity = 10,
                                    },
                                },
                            },
                        },
                    },
                    -- OnClickCallbackList = listEventPopulation,
                },
                {
                    ShortName = "TEXT_IAE_CANCEL",
                },
            },
        },
    },
}


-- 003 - Indenture Villagers to the Bishop
-- receive gold income and influence in exchange for diverting 10% of production to the Bishop
cardChoice[3] = {
    DataType = "EVENT_CHOICE",
    ShortName = "EVENT_IAE_CARD_003_NAME",
    EventActionList = {
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_IAE_CONTAINER_003",
        },
        {
            DataType = "ACTION_SHOW_NARRATIVE_PANEL",
            NarrativePanelData = {
                Title = "EVENT_IAE_CARD_003_NAME",
                Description = "EVENT_IAE_CARD_003_DESC",
                PanelVisual = "ILLUSTRATION_ESTATE_CHURCH",
            },
            ChoiceList = {
                {
                    ShortName = "TEXT_IAE_OK",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "GAME_ACTION_GIVE_RESOURCE_LIST",
                                    BudgetCategory = "TAX_OFFICE",
                                    ResourceCollection = {
                                        {
                                            Resource = "GOLD_COINS",
                                            Quantity = 500,
                                        },
                                    },
                                },
                                {
                                    DataType = "GAME_ACTION_APPLY_GAME_RULE",
                                    RuleModifier = {
                                        DataType = "GAME_RULE_MODIFIER_CROP_YIELDS",
                                        ResourceList = listEventResourceAll,
                                        YieldPercentage = 0.9,
                                        DurationInDays = 60,
                                    },
                                },
                                {
                                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                                    EstateInfluence = {
                                        Estate = "CLERGY",
                                        Quantity = 10,
                                    },
                                },
                            },
                        },
                    },
                    -- OnClickCallbackList = listEventPopulation,
                },
                {
                    ShortName = "TEXT_IAE_CANCEL",
                },
            },
        },
    },
}


-- 004 - Gold from King
-- receive gold lump sum and pay in influence
cardChoice[4] = {
    DataType = "EVENT_CHOICE",
    ShortName = "EVENT_IAE_CARD_004_NAME",
    EventActionList = {
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_IAE_CONTAINER_004",
        },
        {
            DataType = "ACTION_SHOW_NARRATIVE_PANEL",
            NarrativePanelData = {
                Title = "EVENT_IAE_CARD_004_NAME",
                Description = "EVENT_IAE_CARD_004_DESC",
                PanelVisual = "ILLUSTRATION_ESTATE_KING",
            },
            ChoiceList = {
                {
                    ShortName = "EVENT_IAE_GIFT_500_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "GAME_ACTION_GIVE_RESOURCE_LIST",
                                    BudgetCategory = "BUDGET_CATEGORY_GIFT",
                                    ResourceCollection = {
                                        {
                                            Resource = "GOLD_COINS",
                                            Quantity = 500,
                                        },
                                    },
                                },
                                {
                                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                                    EstateInfluence = {
                                        Estate = "KINGDOM",
                                        Quantity = -10,
                                    },
                                },
                            },
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_GIFT_1000_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "GAME_ACTION_GIVE_RESOURCE_LIST",
                                    BudgetCategory = "BUDGET_CATEGORY_GIFT",
                                    ResourceCollection = {
                                        {
                                            Resource = "GOLD_COINS",
                                            Quantity = 1000,
                                        },
                                    },
                                },
                                {
                                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                                    EstateInfluence = {
                                        Estate = "KINGDOM",
                                        Quantity = -20,
                                    },
                                },
                            },
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_GIFT_2000_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "GAME_ACTION_GIVE_RESOURCE_LIST",
                                    BudgetCategory = "BUDGET_CATEGORY_GIFT",
                                    ResourceCollection = {
                                        {
                                            Resource = "GOLD_COINS",
                                            Quantity = 2000,
                                        },
                                    },
                                },
                                {
                                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                                    EstateInfluence = {
                                        Estate = "KINGDOM",
                                        Quantity = -30,
                                    },
                                },
                            },
                        },
                    },
                },
                {
                    ShortName = "TEXT_IAE_CANCEL",
                },
            },
        },
    },
}


-- 005 - Gold from Bishop
-- receive gold lump sum and pay in influence
cardChoice[5] = {
    DataType = "EVENT_CHOICE",
    ShortName = "EVENT_IAE_CARD_005_NAME",
    EventActionList = {
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_IAE_CONTAINER_005",
        },
        {
            DataType = "ACTION_SHOW_NARRATIVE_PANEL",
            NarrativePanelData = {
                Title = "EVENT_IAE_CARD_005_NAME",
                Description = "EVENT_IAE_CARD_005_DESC",
                PanelVisual = "ILLUSTRATION_ESTATE_CHURCH",
            },
            ChoiceList = {
                {
                    ShortName = "EVENT_IAE_GIFT_500_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "GAME_ACTION_GIVE_RESOURCE_LIST",
                                    BudgetCategory = "BUDGET_CATEGORY_GIFT",
                                    ResourceCollection = {
                                        {
                                            Resource = "GOLD_COINS",
                                            Quantity = 500,
                                        },
                                    },
                                },
                                {
                                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                                    EstateInfluence = {
                                        Estate = "CLERGY",
                                        Quantity = -10,
                                    },
                                },
                            },
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_GIFT_1000_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "GAME_ACTION_GIVE_RESOURCE_LIST",
                                    BudgetCategory = "BUDGET_CATEGORY_GIFT",
                                    ResourceCollection = {
                                        {
                                            Resource = "GOLD_COINS",
                                            Quantity = 1000,
                                        },
                                    },
                                },
                                {
                                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                                    EstateInfluence = {
                                        Estate = "CLERGY",
                                        Quantity = -20,
                                    },
                                },
                            },
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_GIFT_2000_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "GAME_ACTION_GIVE_RESOURCE_LIST",
                                    BudgetCategory = "BUDGET_CATEGORY_GIFT",
                                    ResourceCollection = {
                                        {
                                            Resource = "GOLD_COINS",
                                            Quantity = 2000,
                                        },
                                    },
                                },
                                {
                                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                                    EstateInfluence = {
                                        Estate = "CLERGY",
                                        Quantity = -30,
                                    },
                                },
                            },
                        },
                    },
                },
                {
                    ShortName = "TEXT_IAE_CANCEL",
                },
            },
        },
    },
}


-- 006 - Encourage Emigration
-- Get more immigrants in exchange for offering incentives

local function registerImmigrantDeliver(res, qty)
    mod:registerAsset({
        DataType = "QUEST",
        Id = "QUEST_IAE_IMMIGRATIONDELIVER_" .. res,
        Name = "EVENT_IAE_IMMIGRATIONDELIVER_NAME",
        IsSilent = false,
        QuestFunction = {
            DataType = "QUEST_FUNCTION_DELIVER_RESOURCES",
            Estate = "LABOUR",
            ResourceListToDeliver = {
                {
                    Resource = res,
                    Quantity = qty,
                },
            },
            DaysCount = 60,
        },
        QuestRewardActionList = {
            { DataType = "GAME_ACTION_TRIGGER_IMMIGRATION_WAVE", },
            { DataType = "GAME_ACTION_TRIGGER_IMMIGRATION_WAVE", },
            { DataType = "GAME_ACTION_TRIGGER_IMMIGRATION_WAVE", },
            { DataType = "GAME_ACTION_TRIGGER_IMMIGRATION_WAVE", },
            { DataType = "GAME_ACTION_TRIGGER_IMMIGRATION_WAVE", },
            { DataType = "GAME_ACTION_TRIGGER_IMMIGRATION_WAVE", },
        },
        QuestFailList = {
            {
                DataType = "QUEST_REWARD_GAME_RULE",
                RuleModifier = {
                    DataType = "GAME_RULE_MODIFIER_HAPPINESS",
                    Name = "EVENT_IAE_IMMIGRATIONDELIVER_NAME",
                    BonusHappinessPercentage = -0.1,
                    DurationInDays = 30,
                },
            },
        },
    })
end

registerImmigrantDeliver("FISH", 60)
registerImmigrantDeliver("HONEY", 50)
registerImmigrantDeliver("BREAD", 50)
registerImmigrantDeliver("CLOTHES", 50)
registerImmigrantDeliver("CHEESE", 40)
registerImmigrantDeliver("BEER", 30)
registerImmigrantDeliver("WINE", 30)
registerImmigrantDeliver("GOLD_BARS", 20)
registerImmigrantDeliver("JEWELRY", 10)

cardChoice[6] = {
    DataType = "EVENT_CHOICE",
    ShortName = "EVENT_IAE_CARD_006_NAME",
    EventActionList = {
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_IAE_CONTAINER_006",
        },
        {
            DataType = "ACTION_SHOW_NARRATIVE_PANEL",
            NarrativePanelData = {
                Title = "EVENT_IAE_CARD_006_NAME",
                Description = "EVENT_IAE_CARD_006_DESC",
                PanelVisual = "ILLUSTRATION_ESTATE_LABOR",
            },
            ChoiceList = {
                {
                    ShortName = "EVENT_IAE_IMMIGRATIONDELIVER_CHOICE1_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_QUEST",
                            Quest = "QUEST_IAE_IMMIGRATIONDELIVER_FISH",
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_IMMIGRATIONDELIVER_CHOICE2_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_QUEST",
                            Quest = "QUEST_IAE_IMMIGRATIONDELIVER_HONEY",
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_IMMIGRATIONDELIVER_CHOICE3_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_QUEST",
                            Quest = "QUEST_IAE_IMMIGRATIONDELIVER_BREAD",
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_IMMIGRATIONDELIVER_CHOICE4_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_QUEST",
                            Quest = "QUEST_IAE_IMMIGRATIONDELIVER_CLOTHES",
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_IMMIGRATIONDELIVER_CHOICE5_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_QUEST",
                            Quest = "QUEST_IAE_IMMIGRATIONDELIVER_CHEESE",
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_IMMIGRATIONDELIVER_CHOICE6_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_QUEST",
                            Quest = "QUEST_IAE_IMMIGRATIONDELIVER_BEER",
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_IMMIGRATIONDELIVER_CHOICE7_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_QUEST",
                            Quest = "QUEST_IAE_IMMIGRATIONDELIVER_WINE",
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_IMMIGRATIONDELIVER_CHOICE8_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_QUEST",
                            Quest = "QUEST_IAE_IMMIGRATIONDELIVER_GOLD_BARS",
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_IMMIGRATIONDELIVER_CHOICE9_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_QUEST",
                            Quest = "QUEST_IAE_IMMIGRATIONDELIVER_JEWELRY",
                        },
                    },
                },
                {
                    ShortName = "TEXT_IAE_CANCEL",
                },
            },
        },
    },
}


-- 007 - Deliver Materials to the King
-- receive influence in exchange for building materials
local function registerMaterialDeliver(res, qty, est)
    mod:registerAsset({
        DataType = "QUEST",
        Id = "QUEST_IAE_MATERIALSDELIVER_" .. est .. "_" .. res,
        Name = "EVENT_IAE_MATERIALSDELIVER_" .. est .. "_NAME",
        IsSilent = false,
        QuestFunction = {
            DataType = "QUEST_FUNCTION_DELIVER_RESOURCES",
            Estate = est,
            ResourceListToDeliver = {
                {
                    Resource = res,
                    Quantity = qty,
                },
            },
            DaysCount = 60,
        },
        QuestRewardActionList = {
            {
                DataType = "QUEST_REWARD_INFLUENCE",
                EstateInfluence = {
                    Estate = est,
                    Quantity = 10,
                }
            },
        },
        QuestFailList = {
            {
                DataType = "QUEST_REWARD_INFLUENCE",
                EstateInfluence = {
                    Estate = est,
                    Quantity = -5,
                }
            },
        },
    })
end

registerMaterialDeliver("PLANK", 100, "KINGDOM")
registerMaterialDeliver("POLISHED_STONE", 50, "KINGDOM")
registerMaterialDeliver("MARBLE", 40, "KINGDOM")
registerMaterialDeliver("TOOL", 40, "KINGDOM")
registerMaterialDeliver("GLASS", 40, "KINGDOM")


cardChoice[7] = {
    DataType = "EVENT_CHOICE",
    ShortName = "EVENT_IAE_CARD_007_NAME",
    EventActionList = {
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_IAE_CONTAINER_007",
        },
        {
            DataType = "ACTION_SHOW_NARRATIVE_PANEL",
            NarrativePanelData = {
                Title = "EVENT_IAE_CARD_007_NAME",
                Description = "EVENT_IAE_CARD_007_DESC",
                PanelVisual = "ILLUSTRATION_ESTATE_KING",
            },
            ChoiceList = {
                {
                    ShortName = "EVENT_IAE_MATERIALSDELIVER_CHOICE1_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_QUEST",
                            Quest = "QUEST_IAE_MATERIALSDELIVER_KINGDOM_PLANK",
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_MATERIALSDELIVER_CHOICE2_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_QUEST",
                            Quest = "QUEST_IAE_MATERIALSDELIVER_KINGDOM_POLISHED_STONE",
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_MATERIALSDELIVER_CHOICE3_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_QUEST",
                            Quest = "QUEST_IAE_MATERIALSDELIVER_KINGDOM_MARBLE",
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_MATERIALSDELIVER_CHOICE4_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_QUEST",
                            Quest = "QUEST_IAE_MATERIALSDELIVER_KINGDOM_TOOL",
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_MATERIALSDELIVER_CHOICE5_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_QUEST",
                            Quest = "QUEST_IAE_MATERIALSDELIVER_KINGDOM_GLASS",
                        },
                    },
                },
                {
                    ShortName = "TEXT_IAE_CANCEL",
                },
            },
        },
    },
}


-- 008 - Deliver Materials to the Bishop
-- receive influence in exchange for building materials

registerMaterialDeliver("PLANK", 100, "CLERGY")
registerMaterialDeliver("POLISHED_STONE", 50, "CLERGY")
registerMaterialDeliver("MARBLE", 40, "CLERGY")
registerMaterialDeliver("TOOL", 40, "CLERGY")
registerMaterialDeliver("GLASS", 40, "CLERGY")


cardChoice[8] = {
    DataType = "EVENT_CHOICE",
    ShortName = "EVENT_IAE_CARD_008_NAME",
    EventActionList = {
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_IAE_CONTAINER_008",
        },
        {
            DataType = "ACTION_SHOW_NARRATIVE_PANEL",
            NarrativePanelData = {
                Title = "EVENT_IAE_CARD_008_NAME",
                Description = "EVENT_IAE_CARD_008_DESC",
                PanelVisual = "ILLUSTRATION_ESTATE_CHURCH",
            },
            ChoiceList = {
                {
                    ShortName = "EVENT_IAE_MATERIALSDELIVER_CHOICE1_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_QUEST",
                            Quest = "QUEST_IAE_MATERIALSDELIVER_CLERGY_PLANK",
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_MATERIALSDELIVER_CHOICE2_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_QUEST",
                            Quest = "QUEST_IAE_MATERIALSDELIVER_CLERGY_POLISHED_STONE",
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_MATERIALSDELIVER_CHOICE3_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_QUEST",
                            Quest = "QUEST_IAE_MATERIALSDELIVER_CLERGY_MARBLE",
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_MATERIALSDELIVER_CHOICE4_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_QUEST",
                            Quest = "QUEST_IAE_MATERIALSDELIVER_CLERGY_TOOL",
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_MATERIALSDELIVER_CHOICE5_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_QUEST",
                            Quest = "QUEST_IAE_MATERIALSDELIVER_CLERGY_GLASS",
                        },
                    },
                },
                {
                    ShortName = "TEXT_IAE_CANCEL",
                },
            },
        },
    },
}


-- 009 - Deliver Materials to Nearby Lord
-- receive influence in exchange for building materials

registerMaterialDeliver("PLANK", 100, "LABOUR")
registerMaterialDeliver("POLISHED_STONE", 50, "LABOUR")
registerMaterialDeliver("MARBLE", 40, "LABOUR")
registerMaterialDeliver("TOOL", 40, "LABOUR")
registerMaterialDeliver("GLASS", 40, "LABOUR")


cardChoice[9] = {
    DataType = "EVENT_CHOICE",
    ShortName = "EVENT_IAE_CARD_009_NAME",
    EventActionList = {
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_IAE_CONTAINER_009",
        },
        {
            DataType = "ACTION_SHOW_NARRATIVE_PANEL",
            NarrativePanelData = {
                Title = "EVENT_IAE_CARD_009_NAME",
                Description = "EVENT_IAE_CARD_009_DESC",
                PanelVisual = "ILLUSTRATION_ESTATE_LABOR",
            },
            ChoiceList = {
                {
                    ShortName = "EVENT_IAE_MATERIALSDELIVER_CHOICE1_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_QUEST",
                            Quest = "QUEST_IAE_MATERIALSDELIVER_LABOUR_PLANK",
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_MATERIALSDELIVER_CHOICE2_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_QUEST",
                            Quest = "QUEST_IAE_MATERIALSDELIVER_LABOUR_POLISHED_STONE",
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_MATERIALSDELIVER_CHOICE3_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_QUEST",
                            Quest = "QUEST_IAE_MATERIALSDELIVER_LABOUR_MARBLE",
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_MATERIALSDELIVER_CHOICE4_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_QUEST",
                            Quest = "QUEST_IAE_MATERIALSDELIVER_LABOUR_TOOL",
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_MATERIALSDELIVER_CHOICE5_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_QUEST",
                            Quest = "QUEST_IAE_MATERIALSDELIVER_LABOUR_GLASS",
                        },
                    },
                },
                {
                    ShortName = "TEXT_IAE_CANCEL",
                },
            },
        },
    },
}


-- 010 - Reduce working hours
-- Increase labour influence in exchange for lower productivity
cardChoice[10] = {
    DataType = "EVENT_CHOICE",
    ShortName = "EVENT_IAE_CARD_010_NAME",
    EventActionList = {
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_IAE_CONTAINER_010",
        },
        {
            DataType = "ACTION_SHOW_NARRATIVE_PANEL",
            NarrativePanelData = {
                Title = "EVENT_IAE_CARD_010_NAME",
                Description = "EVENT_IAE_CARD_010_DESC",
                PanelVisual = "ILLUSTRATION_ESTATE_LABOR",
            },
            ChoiceList = {
                {
                    ShortName = "EVENT_IAE_REDUCEWORKINGHOURS_30_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "GAME_ACTION_APPLY_GAME_RULE",
                                    RuleModifier = {
                                        DataType = "GAME_RULE_MODIFIER_CROP_YIELDS",
                                        ResourceList = listEventResourceAll,
                                        YieldPercentage = 0.80,
                                        DurationInDays = 30,
                                    },
                                },
                                {
                                    DataType = "QUEST_REWARD_GAME_RULE",
                                    RuleModifier = {
                                        DataType = "GAME_RULE_MODIFIER_HAPPINESS",
                                        BonusHappinessPercentage = 0.20,
                                        DurationInDays = 30,
                                    },
                                },
                                {
                                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                                    EstateInfluence = {
                                        Estate = "LABOUR",
                                        Quantity = 10,
                                    },
                                },
                            },
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_REDUCEWORKINGHOURS_60_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "GAME_ACTION_APPLY_GAME_RULE",
                                    RuleModifier = {
                                        DataType = "GAME_RULE_MODIFIER_CROP_YIELDS",
                                        ResourceList = listEventResourceAll,
                                        YieldPercentage = 0.80,
                                        DurationInDays = 60,
                                    },
                                },
                                {
                                    DataType = "QUEST_REWARD_GAME_RULE",
                                    RuleModifier = {
                                        DataType = "GAME_RULE_MODIFIER_HAPPINESS",
                                        BonusHappinessPercentage = 0.20,
                                        DurationInDays = 60,
                                    },
                                },
                                {
                                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                                    EstateInfluence = {
                                        Estate = "LABOUR",
                                        Quantity = 20,
                                    },
                                },
                            },
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_REDUCEWORKINGHOURS_90_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "GAME_ACTION_APPLY_GAME_RULE",
                                    RuleModifier = {
                                        DataType = "GAME_RULE_MODIFIER_CROP_YIELDS",
                                        ResourceList = listEventResourceAll,
                                        YieldPercentage = 0.80,
                                        DurationInDays = 90,
                                    },
                                },
                                {
                                    DataType = "QUEST_REWARD_GAME_RULE",
                                    RuleModifier = {
                                        DataType = "GAME_RULE_MODIFIER_HAPPINESS",
                                        BonusHappinessPercentage = 0.20,
                                        DurationInDays = 90,
                                    },
                                },
                                {
                                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                                    EstateInfluence = {
                                        Estate = "LABOUR",
                                        Quantity = 30,
                                    },
                                },
                            },
                        },
                    },
                },
                {
                    ShortName = "TEXT_IAE_CANCEL",
                },
            },
        },
    },
}


-- 011 - Trade Influence between Estates
-- Increase influence in one estate at the expense of the others
cardChoice[11] = {
    DataType = "EVENT_CHOICE",
    ShortName = "EVENT_IAE_CARD_011_NAME",
    EventActionList = {
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_IAE_CONTAINER_011",
        },
        {
            DataType = "ACTION_SHOW_NARRATIVE_PANEL",
            NarrativePanelData = {
                Title = "EVENT_IAE_CARD_011_NAME",
                Description = "EVENT_IAE_CARD_011_DESC",
                PanelVisual = "ILLUSTRATION_ESTATE_KING",
            },
            ChoiceList = {
                {
                    ShortName = "EVENT_IAE_HOMAGE_LABOUR_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                                    EstateInfluence = {
                                        Estate = "LABOUR",
                                        Quantity = 20,
                                    },
                                },
                                {
                                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                                    EstateInfluence = {
                                        Estate = "KINGDOM",
                                        Quantity = -10,
                                    },
                                },
                                {
                                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                                    EstateInfluence = {
                                        Estate = "CLERGY",
                                        Quantity = -10,
                                    },
                                },
                            },
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_HOMAGE_KINGDOM_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                                    EstateInfluence = {
                                        Estate = "KINGDOM",
                                        Quantity = 20,
                                    },
                                },
                                {
                                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                                    EstateInfluence = {
                                        Estate = "LABOUR",
                                        Quantity = -10,
                                    },
                                },
                                {
                                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                                    EstateInfluence = {
                                        Estate = "CLERGY",
                                        Quantity = -10,
                                    },
                                },
                            },
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_HOMAGE_CLERGY_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                                    EstateInfluence = {
                                        Estate = "CLERGY",
                                        Quantity = 20,
                                    },
                                },
                                {
                                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                                    EstateInfluence = {
                                        Estate = "LABOUR",
                                        Quantity = -10,
                                    },
                                },
                                {
                                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                                    EstateInfluence = {
                                        Estate = "KINGDOM",
                                        Quantity = -10,
                                    },
                                },
                            },
                        },
                    },
                },
                {
                    ShortName = "TEXT_IAE_CANCEL",
                },
            },
        },
    },
}



-- 012 - Special Trade Mission
-- Exchange items

local function registerTrade(id, res1, qty1, res2, qty2)
    mod:registerAsset({
        DataType = "QUEST",
        Id = "QUEST_IAE_TRADE" .. id,
        IsSilent = false,
        QuestFunction = {
            DataType = "QUEST_FUNCTION_DELIVER_RESOURCES",
            Estate = "LABOUR",
            ResourceListToDeliver = {
                {
                    Resource = res1,
                    Quantity = qty1,
                },
            },
            DaysCount = 30,
        },
        QuestRewardActionList = {
            {
                DataType = "QUEST_REWARD_RESOURCES",
                BudgetCategory = "TRADE",
                ResourceCollection = {
                    {
                        Resource = res2,
                        Quantity = qty2
                    },
                },
            },
            {
                DataType = "GAME_ACTION_GIVE_INFLUENCE",
                EstateInfluence = {
                    Estate = "LABOUR",
                    Quantity = 5,
                },
            },
        },
        QuestFailList = {
            {
                DataType = "GAME_ACTION_GIVE_INFLUENCE",
                EstateInfluence = {
                    Estate = "LABOUR",
                    Quantity = -5,
                },
            },
        },
    })
end

registerTrade(1, "BREAD", 100, "PLANK", 200)
registerTrade(2, "PLANK", 100, "CHEESE", 200)

registerTrade(3, "CHEESE", 100, "POLISHED_STONE", 200)
registerTrade(4, "POLISHED_STONE", 100, "BREAD", 200)

registerTrade(5, "FISH", 100, "TOOL", 25)
registerTrade(6, "HONEY", 100, "CLOTHES", 200)

registerTrade(7, "BREAD", 100, "IRON", 50)
registerTrade(8, "TOOL", 100, "HONEY", 200)


cardChoice[12] = {
    DataType = "EVENT_CHOICE",
    ShortName = "EVENT_IAE_CARD_012_NAME",
    EventActionList = {
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_IAE_CONTAINER_012",
        },
        {
            DataType = "ACTION_SHOW_NARRATIVE_PANEL",
            NarrativePanelData = {
                Title = "EVENT_IAE_CARD_012_NAME",
                Description = "EVENT_IAE_CARD_012_DESC",
                PanelVisual = "ILLUSTRATION_ESTATE_LABOR",
            },
            ChoiceList = {
                {
                    ShortName = "EVENT_IAE_TRADE1_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "EVENT_ACTION_GIVE_QUEST",
                                    Quest = "QUEST_IAE_TRADE1",
                                },
                            },
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_TRADE2_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "EVENT_ACTION_GIVE_QUEST",
                                    Quest = "QUEST_IAE_TRADE2",
                                },
                            },
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_TRADE3_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "EVENT_ACTION_GIVE_QUEST",
                                    Quest = "QUEST_IAE_TRADE3",
                                },
                            },
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_TRADE4_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "EVENT_ACTION_GIVE_QUEST",
                                    Quest = "QUEST_IAE_TRADE4",
                                },
                            },
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_TRADE5_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "EVENT_ACTION_GIVE_QUEST",
                                    Quest = "QUEST_IAE_TRADE5",
                                },
                            },
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_TRADE6_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "EVENT_ACTION_GIVE_QUEST",
                                    Quest = "QUEST_IAE_TRADE6",
                                },
                            },
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_TRADE7_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "EVENT_ACTION_GIVE_QUEST",
                                    Quest = "QUEST_IAE_TRADE7",
                                },
                            },
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_TRADE8_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "EVENT_ACTION_GIVE_QUEST",
                                    Quest = "QUEST_IAE_TRADE8",
                                },
                            },
                        },
                    },
                },
                {
                    ShortName = "TEXT_IAE_CANCEL",
                },
            },
        },
    },
}



-- 013 - Eat, Drink and Be Merry
-- Villagers eat and drink more often in exchange for influence
cardChoice[13] = {
    DataType = "EVENT_CHOICE",
    ShortName = "EVENT_IAE_CARD_013_NAME",
    EventActionList = {
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_IAE_CONTAINER_013",
        },
        {
            DataType = "EVENT_ACTION_GIVE_REWARD",
            ActionList = {
                {
                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                    EstateInfluence = {
                        Estate = "LABOUR",
                        Quantity = 15,
                    },
                },
                {
                    DataType = "QUEST_REWARD_GAME_RULE",
                    RuleModifier = {
                        DataType = "GAME_RULE_MODIFIER_NEED_TYPE_DEPLETE_RATE",
                        Name = "EVENT_IAE_CARD_013_NAME",
                        NeedType = "NEED_FOOD",
                        BonusInPerc = -0.2,
                        DurationInDays = 60,
                    },
                },
                {
                    DataType = "QUEST_REWARD_GAME_RULE",
                    RuleModifier = {
                        DataType = "GAME_RULE_MODIFIER_NEED_TYPE_DEPLETE_RATE",
                        Name = "EVENT_IAE_CARD_013_NAME",
                        NeedType = "NEED_WATER",
                        BonusInPerc = -0.2,
                        DurationInDays = 60,
                    },
                },
                {
                    DataType = "QUEST_REWARD_GAME_RULE",
                    RuleModifier = {
                        DataType = "GAME_RULE_MODIFIER_NEED_TYPE_DEPLETE_RATE",
                        Name = "EVENT_IAE_CARD_013_NAME",
                        NeedType = "NEED_LUXURY",
                        BonusInPerc = -0.2,
                        DurationInDays = 60,
                    },
                },
            },
        },
    },
}


-- 014 - Beg for Food from the King
-- Decrease kingdom influence, get emergency food
cardChoice[14] = {
    DataType = "EVENT_CHOICE",
    ShortName = "EVENT_IAE_CARD_014_NAME",
    EventActionList = {
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_IAE_CONTAINER_014",
        },
        {
            DataType = "ACTION_SHOW_NARRATIVE_PANEL",
            NarrativePanelData = {
                Title = "EVENT_IAE_CARD_014_NAME",
                Description = "EVENT_IAE_CARD_014_DESC",
                PanelVisual = "ILLUSTRATION_ESTATE_KING",
            },
            ChoiceList = {
                {
                    ShortName = "EVENT_IAE_BEGFOOD_KINGDOM1_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                                    EstateInfluence = {
                                        Estate = "KINGDOM",
                                        Quantity = -10,
                                    },
                                },
                                {
                                    DataType = "QUEST_REWARD_RESOURCES",
                                    BudgetCategory = "MISCELLANEOUS",
                                    ResourceCollection = {
                                        {
                                            Resource = "BREAD",
                                            Quantity = 200
                                        },
                                    },
                                },
                            },
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_BEGFOOD_KINGDOM2_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                                    EstateInfluence = {
                                        Estate = "KINGDOM",
                                        Quantity = -20,
                                    },
                                },
                                {
                                    DataType = "QUEST_REWARD_RESOURCES",
                                    BudgetCategory = "MISCELLANEOUS",
                                    ResourceCollection = {
                                        {
                                            Resource = "BREAD",
                                            Quantity = 400
                                        },
                                    },
                                },
                            },
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_BEGFOOD_KINGDOM3_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                                    EstateInfluence = {
                                        Estate = "KINGDOM",
                                        Quantity = -30,
                                    },
                                },
                                {
                                    DataType = "QUEST_REWARD_RESOURCES",
                                    BudgetCategory = "MISCELLANEOUS",
                                    ResourceCollection = {
                                        {
                                            Resource = "BREAD",
                                            Quantity = 600
                                        },
                                    },
                                },
                            },
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_BEGFOOD_KINGDOM4_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                                    EstateInfluence = {
                                        Estate = "KINGDOM",
                                        Quantity = -40,
                                    },
                                },
                                {
                                    DataType = "QUEST_REWARD_RESOURCES",
                                    BudgetCategory = "MISCELLANEOUS",
                                    ResourceCollection = {
                                        {
                                            Resource = "BREAD",
                                            Quantity = 800
                                        },
                                    },
                                },
                            },
                        },
                    },
                },
                {
                    ShortName = "TEXT_IAE_CANCEL",
                },
            },
        },
    },
}



-- 015 - Beg for Food from the Bishop
-- Decrease clergy influence, get emergency food
cardChoice[15] = {
    DataType = "EVENT_CHOICE",
    ShortName = "EVENT_IAE_CARD_015_NAME",
    EventActionList = {
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_IAE_CONTAINER_015",
        },
        {
            DataType = "ACTION_SHOW_NARRATIVE_PANEL",
            NarrativePanelData = {
                Title = "EVENT_IAE_CARD_015_NAME",
                Description = "EVENT_IAE_CARD_015_DESC",
                PanelVisual = "ILLUSTRATION_ESTATE_CHURCH",
            },
            ChoiceList = {
                {
                    ShortName = "EVENT_IAE_BEGFOOD_CLERGY1_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                                    EstateInfluence = {
                                        Estate = "CLERGY",
                                        Quantity = -10,
                                    },
                                },
                                {
                                    DataType = "QUEST_REWARD_RESOURCES",
                                    BudgetCategory = "MISCELLANEOUS",
                                    ResourceCollection = {
                                        {
                                            Resource = "CHEESE",
                                            Quantity = 200
                                        },
                                    },
                                },
                            },
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_BEGFOOD_CLERGY2_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                                    EstateInfluence = {
                                        Estate = "CLERGY",
                                        Quantity = -20,
                                    },
                                },
                                {
                                    DataType = "QUEST_REWARD_RESOURCES",
                                    BudgetCategory = "MISCELLANEOUS",
                                    ResourceCollection = {
                                        {
                                            Resource = "CHEESE",
                                            Quantity = 400
                                        },
                                    },
                                },
                            },
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_BEGFOOD_CLERGY3_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                                    EstateInfluence = {
                                        Estate = "CLERGY",
                                        Quantity = -30,
                                    },
                                },
                                {
                                    DataType = "QUEST_REWARD_RESOURCES",
                                    BudgetCategory = "MISCELLANEOUS",
                                    ResourceCollection = {
                                        {
                                            Resource = "CHEESE",
                                            Quantity = 600
                                        },
                                    },
                                },
                            },
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_BEGFOOD_CLERGY4_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                                    EstateInfluence = {
                                        Estate = "CLERGY",
                                        Quantity = -40,
                                    },
                                },
                                {
                                    DataType = "QUEST_REWARD_RESOURCES",
                                    BudgetCategory = "MISCELLANEOUS",
                                    ResourceCollection = {
                                        {
                                            Resource = "CHEESE",
                                            Quantity = 800
                                        },
                                    },
                                },
                            },
                        },
                    },
                },
                {
                    ShortName = "TEXT_IAE_CANCEL",
                },
            },
        },
    },
}



-- 016 - Hire Military Experts
-- Increase rate of soldier training and recovery
cardChoice[16] = {
    DataType = "EVENT_CHOICE",
    ShortName = "EVENT_IAE_CARD_016_NAME",
    EventActionList = {
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_IAE_CONTAINER_016",
        },
        {
            DataType = "GAME_ACTION_GIVE_INFLUENCE",
            EstateInfluence = {
                Estate = "KINGDOM",
                Quantity = -10,
            },
        },
        {
            DataType = "EVENT_ACTION_GIVE_REWARD",
            ActionList = {
                {
                    DataType = "GAME_ACTION_APPLY_GAME_RULE",
                    RuleModifier = {
                        DataType = "GAME_RULE_MODIFIER_MILITARY_TRAINING",
                        XPBonusPercentage = 0.5,
                        DurationInDays = 60,
                    },
                },
                {
                    DataType = "GAME_ACTION_APPLY_GAME_RULE",
                    RuleModifier = {
                        DataType = "GAME_RULE_MODIFIER_SOLDIER_RECOVERY_SPEED",
                        Bonus = 2.0,
                        DurationInDays = 60,
                    },
                },
            },
        },
    },
}


-- 017 - Focus Production
-- Increase production of food or goods, at the expense of the other
cardChoice[17] = {
    DataType = "EVENT_CHOICE",
    ShortName = "EVENT_IAE_CARD_017_NAME",
    EventActionList = {
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_IAE_CONTAINER_017",
        },
        {
            DataType = "ACTION_SHOW_NARRATIVE_PANEL",
            NarrativePanelData = {
                Title = "EVENT_IAE_CARD_017_NAME",
                Description = "EVENT_IAE_CARD_017_DESC",
                PanelVisual = "ILLUSTRATION_ESTATE_LABOR",
            },
            ChoiceList = {
                {
                    ShortName = "EVENT_IAE_PRODUCTIONFOCUS_FOOD_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "GAME_ACTION_APPLY_GAME_RULE",
                                    RuleModifier = {
                                        DataType = "GAME_RULE_MODIFIER_CROP_YIELDS",
                                        ResourceList = listEventResourceFood,
                                        YieldPercentage = 1.20,
                                        DurationInDays = 60,
                                    },
                                },
                                {
                                    DataType = "GAME_ACTION_APPLY_GAME_RULE",
                                    RuleModifier = {
                                        DataType = "GAME_RULE_MODIFIER_CROP_YIELDS",
                                        ResourceList = listEventResourceGoods,
                                        YieldPercentage = 0.80,
                                        DurationInDays = 60,
                                    },
                                },
                            },
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_PRODUCTIONFOCUS_GOODS_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "GAME_ACTION_APPLY_GAME_RULE",
                                    RuleModifier = {
                                        DataType = "GAME_RULE_MODIFIER_CROP_YIELDS",
                                        ResourceList = listEventResourceGoods,
                                        YieldPercentage = 1.20,
                                        DurationInDays = 60,
                                    },
                                },
                                {
                                    DataType = "GAME_ACTION_APPLY_GAME_RULE",
                                    RuleModifier = {
                                        DataType = "GAME_RULE_MODIFIER_CROP_YIELDS",
                                        ResourceList = listEventResourceFood,
                                        YieldPercentage = 0.80,
                                        DurationInDays = 60,
                                    },
                                },
                            },
                        },
                    },
                },
                {
                    ShortName = "TEXT_IAE_CANCEL",
                },
            },
        },
    },
}


-- 018 - Increase working hours
-- Decrease labour influence and happiness in exchange for higher productivity
cardChoice[18] = {
    DataType = "EVENT_CHOICE",
    ShortName = "EVENT_IAE_CARD_018_NAME",
    EventActionList = {
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_IAE_CONTAINER_018",
        },
        {
            DataType = "ACTION_SHOW_NARRATIVE_PANEL",
            NarrativePanelData = {
                Title = "EVENT_IAE_CARD_018_NAME",
                Description = "EVENT_IAE_CARD_018_DESC",
                PanelVisual = "ILLUSTRATION_ESTATE_LABOR",
            },
            ChoiceList = {
                {
                    ShortName = "EVENT_IAE_INCREASEWORKINGHOURS_30_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "GAME_ACTION_APPLY_GAME_RULE",
                                    RuleModifier = {
                                        DataType = "GAME_RULE_MODIFIER_CROP_YIELDS",
                                        ResourceList = listEventResourceAll,
                                        YieldPercentage = 1.20,
                                        DurationInDays = 30,
                                    },
                                },
                                {
                                    DataType = "QUEST_REWARD_GAME_RULE",
                                    RuleModifier = {
                                        DataType = "GAME_RULE_MODIFIER_HAPPINESS",
                                        BonusHappinessPercentage = -0.20,
                                        DurationInDays = 30,
                                    },
                                },
                                {
                                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                                    EstateInfluence = {
                                        Estate = "LABOUR",
                                        Quantity = -10,
                                    },
                                },
                            },
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_INCREASEWORKINGHOURS_60_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "GAME_ACTION_APPLY_GAME_RULE",
                                    RuleModifier = {
                                        DataType = "GAME_RULE_MODIFIER_CROP_YIELDS",
                                        ResourceList = listEventResourceAll,
                                        YieldPercentage = 1.20,
                                        DurationInDays = 60,
                                    },
                                },
                                {
                                    DataType = "QUEST_REWARD_GAME_RULE",
                                    RuleModifier = {
                                        DataType = "GAME_RULE_MODIFIER_HAPPINESS",
                                        BonusHappinessPercentage = -0.20,
                                        DurationInDays = 60,
                                    },
                                },
                                {
                                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                                    EstateInfluence = {
                                        Estate = "LABOUR",
                                        Quantity = -20,
                                    },
                                },
                            },
                        },
                    },
                },
                {
                    ShortName = "EVENT_IAE_REDUCEWORKINGHOURS_90_NAME",
                    EventActionList = {
                        {
                            DataType = "EVENT_ACTION_GIVE_REWARD",
                            ActionList = {
                                {
                                    DataType = "GAME_ACTION_APPLY_GAME_RULE",
                                    RuleModifier = {
                                        DataType = "GAME_RULE_MODIFIER_CROP_YIELDS",
                                        ResourceList = listEventResourceAll,
                                        YieldPercentage = 1.20,
                                        DurationInDays = 90,
                                    },
                                },
                                {
                                    DataType = "QUEST_REWARD_GAME_RULE",
                                    RuleModifier = {
                                        DataType = "GAME_RULE_MODIFIER_HAPPINESS",
                                        Name = "EVENT_IAE_CARD_001_NAME",
                                        BonusHappinessPercentage = -0.20,
                                        DurationInDays = 90,
                                    },
                                },
                                {
                                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                                    EstateInfluence = {
                                        Estate = "LABOUR",
                                        Quantity = -30,
                                    },
                                },
                            },
                        },
                    },
                },
                {
                    ShortName = "TEXT_IAE_CANCEL",
                },
            },
        },
    },
}



-- 019 - Insult the Bishop
-- Reduces church need at the expense of influence
cardChoice[19] = {
    DataType = "EVENT_CHOICE",
    ShortName = "EVENT_IAE_CARD_019_NAME",
    EventActionList = {
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_IAE_CONTAINER_019",
        },
        {
            DataType = "GAME_ACTION_GIVE_INFLUENCE",
            EstateInfluence = {
                Estate = "CLERGY",
                Quantity = -20,
            },
        },
        {
            DataType = "EVENT_ACTION_GIVE_REWARD",
            ActionList = {
                {
                    DataType = "GAME_ACTION_APPLY_GAME_RULE",
                    RuleModifier = {
                        DataType = "GAME_RULE_MODIFIER_NEED_TYPE_DEPLETE_RATE",
                        NeedType = "NEED_SERVICE",
                        BonusInPerc = 3.0,
                        DurationInDays = 90,
                    },
                },
            },
        },
    },
}


-- 020 - Proclaim a Fast
-- Reduce production and consumption, gives clergy influence
cardChoice[20] = {
    DataType = "EVENT_CHOICE",
    ShortName = "EVENT_IAE_CARD_020_NAME",
    EventActionList = {
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_IAE_CONTAINER_020",
        },
        {
            DataType = "EVENT_ACTION_GIVE_REWARD",
            ActionList = {
                {
                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                    EstateInfluence = {
                        Estate = "CLERGY",
                        Quantity = 10,
                    },
                },
                {
                    DataType = "GAME_ACTION_APPLY_GAME_RULE",
                    RuleModifier = {
                        DataType = "GAME_RULE_MODIFIER_CROP_YIELDS",
                        ResourceList = listEventResourceAll,
                        YieldPercentage = 0.80,
                        DurationInDays = 30,
                    },
                },
                {
                    DataType = "GAME_ACTION_APPLY_GAME_RULE",
                    RuleModifier = {
                        DataType = "GAME_RULE_MODIFIER_NEED_TYPE_DEPLETE_RATE",
                        NeedType = "NEED_FOOD",
                        BonusInPerc = 1.0,
                        DurationInDays = 30,
                    },
                },
                {
                    DataType = "GAME_ACTION_APPLY_GAME_RULE",
                    RuleModifier = {
                        DataType = "GAME_RULE_MODIFIER_NEED_TYPE_DEPLETE_RATE",
                        NeedType = "NEED_WATER",
                        BonusInPerc = 1.0,
                        DurationInDays = 30,
                    },
                },
                {
                    DataType = "GAME_ACTION_APPLY_GAME_RULE",
                    RuleModifier = {
                        DataType = "GAME_RULE_MODIFIER_NEED_TYPE_DEPLETE_RATE",
                        NeedType = "NEED_LUXURY",
                        BonusInPerc = 1.0,
                        DurationInDays = 30,
                    },
                },
            },
        },
    },
}


-- 021 - Ration food
-- Reduce production and consumption, lose labour influence
cardChoice[21] = {
    DataType = "EVENT_CHOICE",
    ShortName = "EVENT_IAE_CARD_021_NAME",
    EventActionList = {
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_IAE_CONTAINER_021",
        },
        {
            DataType = "EVENT_ACTION_GIVE_REWARD",
            ActionList = {
                {
                    DataType = "GAME_ACTION_GIVE_INFLUENCE",
                    EstateInfluence = {
                        Estate = "LABOUR",
                        Quantity = -10,
                    },
                },
                {
                    DataType = "GAME_ACTION_APPLY_GAME_RULE",
                    RuleModifier = {
                        DataType = "GAME_RULE_MODIFIER_NEED_TYPE_DEPLETE_RATE",
                        NeedType = "NEED_FOOD",
                        BonusInPerc = 0.20,
                        DurationInDays = 60,
                    },
                },
                {DataType = "GAME_ACTION_APPLY_GAME_RULE",
                    RuleModifier = {
                        DataType = "GAME_RULE_MODIFIER_NEED_TYPE_DEPLETE_RATE",
                        NeedType = "NEED_WATER",
                        BonusInPerc = 0.20,
                        DurationInDays = 60,
                    },
                },
                {
                    DataType = "GAME_ACTION_APPLY_GAME_RULE",
                    RuleModifier = {
                        DataType = "GAME_RULE_MODIFIER_NEED_TYPE_DEPLETE_RATE",
                        NeedType = "NEED_LUXURY",
                        BonusInPerc = 0.20,
                        DurationInDays = 60,
                    },
                },
            },
        },
    },
}


-- 022 - Join the King on a Crusade
-- Send troops and win loot in battle
cardChoice[22] = {
    DataType = "EVENT_CHOICE",
    ShortName = "EVENT_IAE_CARD_022_NAME",
    EventActionList = {
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_IAE_CONTAINER_022",
        },
        {
            DataType = "EVENT_ACTION_GIVE_REWARD",
            ActionList = {
                {
                    DataType = "GAME_ACTION_APPLY_GAME_RULE",
                    RuleModifier = {
                        DataType = "GAME_RULE_MODIFIER_MILITARY_TRAINING",
                        XPBonusPercentage = 0.1,
                        DurationInDays = 30,
                    },
                },
                {
                    DataType = "EVENT_ACTION_TRIGGER_MILITARY_CAMPAIGN",
                    AssetCampaign = "MILITARY_CAMPAIGN_EASY",
                },
                {
                    DataType = "EVENT_ACTION_TRIGGER_MILITARY_CAMPAIGN",
                    AssetCampaign = "MILITARY_CAMPAIGN_AVERAGE",
                },
                {
                    DataType = "EVENT_ACTION_TRIGGER_MILITARY_CAMPAIGN",
                    AssetCampaign = "MILITARY_CAMPAIGN_HARD",
                },
            },
        },
    },
}


-- differentiate military mission notifications and text
mod:registerAsset({
    DataType = "NOTIFICATION",
    Id = "NOTIFICATION_EVENT_IAE_MILITARY_EASY",
    Title = "MC_EVENT_IAE_MILITARY_EASY_EV_01_TITLE",
    Description = "MC_EVENT_IAE_MILITARY_EASY_EV_01_DESC",
    Severity = 1,
    DelayBeforeHide = 60 * 20,
})

mod:overrideAsset({
    Id = "MILITARY_CAMPAIGN_EASY",
    Title = "EVENT_IAE_MILITARY_EASY",
    AssetNotification = "NOTIFICATION_EVENT_IAE_MILITARY_EASY",
})

mod:registerAsset({
    DataType = "NOTIFICATION",
    Id = "NOTIFICATION_EVENT_IAE_MILITARY_AVERAGE",
    Title = "MC_EVENT_IAE_MILITARY_AVERAGE_EV_01_TITLE",
    Description = "MC_EVENT_IAE_MILITARY_AVERAGE_EV_01_DESC",
    Severity = 1,
    DelayBeforeHide = 60 * 20,
})

mod:overrideAsset({
    Id = "MILITARY_CAMPAIGN_AVERAGE",
    Title = "EVENT_IAE_MILITARY_AVERAGE",
    AssetNotification = "NOTIFICATION_EVENT_IAE_MILITARY_AVERAGE",
})

mod:registerAsset({
    DataType = "NOTIFICATION",
    Id = "NOTIFICATION_EVENT_IAE_MILITARY_HARD",
    Title = "MC_EVENT_IAE_MILITARY_HARD_EV_01_TITLE",
    Description = "MC_EVENT_IAE_MILITARY_HARD_EV_01_DESC",
    Severity = 1,
    DelayBeforeHide = 60 * 20,
})

mod:overrideAsset({
    Id = "MILITARY_CAMPAIGN_HARD",
    Title = "EVENT_IAE_MILITARY_HARD",
    AssetNotification = "NOTIFICATION_EVENT_IAE_MILITARY_HARD",
})

-- do not issue the campaigns by default anymore, only as part of monthly cards
mod:overrideAsset({
    Id = "MILITARY_CAMPAIGN_EASY",
    ConditionList = {
        {
            DataType = "GAME_CONDITION_MONTHLY_TRADE_REVENUE",
            MonthlyRevenue = 999999,
        },
    },
})

mod:overrideAsset({
    Id = "MILITARY_CAMPAIGN_AVERAGE",
    ConditionList = {
        {
            DataType = "GAME_CONDITION_MONTHLY_TRADE_REVENUE",
            MonthlyRevenue = 999999,
        },
    },
})

mod:overrideAsset({
    Id = "MILITARY_CAMPAIGN_HARD",
    ConditionList = {
        {
            DataType = "GAME_CONDITION_MONTHLY_TRADE_REVENUE",
            MonthlyRevenue = 999999,
        },
    },
})



-- Monthly Choice Notification ------------------------------------------------------------------------------------
-- Create enough to cover 25 years of game time (25 * 12 = 300 events)
local dayFirstChoice = 15
local daysBetweenChoice = 28
-- local dayFirstChoice = 1 -- FOR TESTING
-- local daysBetweenChoice = 1 -- FOR TESTING

-- -- Notification
-- mod:registerAsset({
--     DataType = "NOTIFICATION",
--     Id = "NOTIFICATION_IAE_MONTHLY",
--     Title = "EVENT_IAE_MONTHLY_NAME",
--     Description = "EVENT_IAE_MONTHLY_DESC",
--     Severity = 1,
--     DelayBeforeHide = (60 * 5),
-- })

-- Events
for i = 1, 300, 1 do

    -- timing
    local delayDays = (dayFirstChoice + ((i - 1) * daysBetweenChoice)) -- 30 seconds after the start of the first day, with events coming every x days afterwards

    -- Pick three random cards and make sure there are no duplicates
    local cardSelected1 = math.random(1, #cardChoice)
    local cardSelected2 = math.random(1, #cardChoice)
    local cardSelected3 = math.random(1, #cardChoice)
    repeat
        cardSelected2 = math.random(1, #cardChoice)
    until (cardSelected2 ~= cardSelected1)
    repeat
        cardSelected3 = math.random(1, #cardChoice)
    until (cardSelected3 ~= cardSelected1) and (cardSelected3 ~= cardSelected2)

    -- Create an event with the appropriate delay, containing the three random card choices
    mod:registerAsset({
        DataType = "EVENT",
        Id = "EVENT_IAE_MONTHLY_" .. string.sub("000" .. i, -3),
        DaysToFirst = delayDays,
        Delay = 10 - 60 + (60 * delayDays),
        ConditionList = {
            {
                DataType = "GAME_CONDITION_BUILDING_BUILT",
                AssetBuilding = "BUILDING_VILLAGE_CENTER",
            }
        },
        ActionList = {
            {
                DataType = "ACTION_SHOW_NARRATIVE_PANEL",
                -- AssetNotification = "NOTIFICATION_IAE_MONTHLY",
                NarrativePanelData = {
                    Title = "EVENT_IAE_MONTHLY_NAME",
                    Description = "EVENT_IAE_MONTHLY_DESC",
                    PanelVisual = "ILLUSTRATION_ESTATE_KING",
                },
                ChoiceList = {
                    cardChoice[cardSelected1],
                    cardChoice[cardSelected2],
                    cardChoice[cardSelected3],
                    -- cardChoice[22], -- FOR TESTING
                    -- cardChoice[22], -- FOR TESTING
                    -- cardChoice[22], -- FOR TESTING
                    {
                        ShortName = "EVENT_IAE_CARD_000_NAME",
                    },
                },
            },
        },
    })

    mod:overrideAsset({
        Id = "DEFAULT_BALANCING",
        EventList = {
            Action = "APPEND",
            "EVENT_IAE_MONTHLY_" .. string.sub("000" .. i, -3),
        },
    })

end
